--[[======================================================
com.neurogami.Erode.xrnx/main.lua
=======================================================]]--



TOOL_NAME = "Erode"
U  = require (TOOL_NAME .. '/Utilities')

require (TOOL_NAME .. '/OscDevice')
require (TOOL_NAME .. '/Handlers')
require (TOOL_NAME .. '/Configuration')
require (TOOL_NAME .. '/Core')
require (TOOL_NAME .. '/Gui')

-- Reload the script whendever this file is saved. 
_AUTO_RELOAD_DEBUG = true

-- TODO Move to Utils
local function clamp_value(value, min_value, max_value)
  return math.min(max_value, math.max(value, min_value))
end

local osc_client, socket_error = nil
local osc_server, server_socket_error = nil
local osc_device = nil

-- TODO: Add GUI config thing
function create_osc_server()
  print("ERODE TO CREATE OSC SERVER!!!")
  osc_server, server_socket_error = renoise.Socket.create_server(
  configuration.osc_settings.internal.ip.value, 
  configuration.osc_settings.internal.port.value, 
  renoise.Socket.PROTOCOL_UDP)
  
  osc_device = OscDevice()

--  RENOISE_OSC = osc_device:renoise_osc()
 -- CONTROLLER_OSC = osc_device:controller_osc()

  load_handlers(osc_device)

  if (server_socket_error) then 
    renoise.app():show_warning(("Oh noes! Failed to start the " .. 
    TOOL_NAME .. " OSC server. Error: '%s'"):format(server_socket_error))
    return
  else
    print("* * " ..TOOL_NAME, " has created a osc_server on port ", configuration.osc_settings.internal.port.value )
    osc_server:run(osc_device)
  end

end


class "RenoiseScriptingTool" (renoise.Document.DocumentNode)
  function RenoiseScriptingTool:__init()    
    renoise.Document.DocumentNode.__init(self) 
    self:add_property("Name", "Untitled Tool")
    self:add_property("Id", "Unknown Id") 
    self:add_property("Version", "Unknown version") 
  end

local manifest = RenoiseScriptingTool()
local ok,err = manifest:load_from("manifest.xml")
GUI.tool_name = manifest:property("Name").value
GUI.tool_id = manifest:property("Id").value
GUI.tool_version = manifest:property("Version").value

print("Erode has version: " .. GUI.tool_version)

function erode_launch()
  GUI.show_dialog() 
end

renoise.tool():add_menu_entry {
  name = "--- Main Menu:Tools:Neurogami " .. TOOL_NAME .. ": Launch ...",
  invoke = erode_launch
}


-- Experiment: have an OSC server start on song load.
-- Later, move that code toa "shared" tool
-- http://neurogami.com/blog/neurogami-sharing-lua-files-in-renoise.html

renoise.tool().app_new_document_observable:add_notifier(
function()
  print(TOOL_NAME .. "app_new_document_observable notifier called.")

  Core.current_song = renoise.song()
  create_osc_server()
end
)

------- keys --------------------------

renoise.tool():add_keybinding {
  name = "Global:Tools:Neurogami " .. TOOL_NAME .. " Erode GUI",
  invoke = erode_launch
}  


